# Equinox's Mod Utils

![Banner Image](https://i.imgur.com/fV8R9eg.png)

## Description

This is a collection of tools for modders to use to make developing mods easier and avoid duplicating code. 

**Modders:** Please look at the GitHub link to see what this library provides and how to use it.

## Installation

If you are using Techtonica Mod Loader, you can ignore these steps.

Note, this mod requires use of the BepInEx Update function. If you have not already done so for another mod, follow these instructions:
1. Find your game install folder.
2. Navigate to BepInEx\config.
3. Open BepInEx.cfg.
4. Find the setting "HideGameManagerObject".
5. Set it to "true".
6. Save & close.

### Techtonica Mod Loader Installation

You can download the Techtonica Mod Loader from [here](https://github.com/CubeSuite/TechtonicaModLoader/releases) and use that to install this mod.

### Manual Install Instructions

Note: If you are playing on Gamepass, your game version is likely behind the steam version. Please check the version compatibility chart below.

Your game folder is likely in one of these places:  
    • Steam: (A-Z):/steam/steamapps/common/Techtonica  
    • Gamepass: (A-Z):/XboxGames/Techtonica/Content  
    • Gamepass: Could also be in C:/Program Data/WindowsApps  

1. Download BepInEx v5.4.21 from [here](https://github.com/BepInEx/BepInEx/releases)
1. Follow the installation instructions [here](https://docs.bepinex.dev/articles/user_guide/installation/index.html)
1. Download and install any dependencies.
1. Extract the contents of the .zip file for this mod.
1. Drag the "BepInEx" folder into your game folder.
1. Change config options. 

## Known Issues

- Second Load 
  - Custom unlocks will not load correctly except for during the first load of a session.

## Changelog

### V4.0.0

- Added: Data Saving Functions
  - Added functions that allows modders to save variables to machine instances.
- Added: AddResource()
  - Added a function that allows modders to easily add new items to the game.
- Added: AddRecipe()
  - Added a function that allows modders to easily add new recipes to the game
- Fixed: Non-Unique Fields
  - If two unlocks have the same name or description, an error will occur when adding them to the translation dictionary.
- Fixed: Save Unlock Name
  - Uninstalling a mod will cause it's unlock state to be used for a different mod's unlock
- Changed: Unique Names
  - Reject new Unlocks that do not have unique names
- Added: Game Saved Event
  - Added an event that is fired as a postfix to the game saving, with the world name as the sender
- Changed: Logging Format
  - Now using BepInEx logger instead of Unity logger
- Added: Debug Object Function
  - Added a function that prints all members of an object.
- Changed: SaveStateLoaded
  - Changed the SaveStateLoaded checking code to wait until SaveState.instance.metadata.worldName is not null or empty
- Added: PacedLog
  - Added a function that calls Debug.Log() if enough time has passed since the last call
- Changed: Update Names
  - ResourceNames and UnlockNames have been updated for 0.4.0

### V3.3.1

- Fixed EMU UnlockState saving, for realsies this time. (Hopefully).

### V3.3.0

- Added:
  - public static bool hasMachineManagerLoaded;
  - public static event EventHandler MachineManagerLoaded;
- Fixed EMU saving things it shouldn't. 
  - This should prevent the two bugs that were partially fixed in the last release.
- Added IsModInstalled()
- Added GetImageForResource()

### V3.2.0

- Added ResourceNames.SafeResources
  - This is a list of all resource names that have had any spoilers removed.
- Fixed a bug that caused the Tech Tree Menu to not open (maybe).
- Fixed a bug that caused the Energy tab of the Tech Tree Menu to not open (maybe).

### V3.1.0

- Honestly don't know, forgot to write this at the time of release.

### V3.0.0

- Updated for game version 0.3.0e
- Fixed a bug that caused errors for missing custom unlocks from other mods.
- Added function NullCheck()

### V2.3.1

- Fixed a bug where certain buildings wouldn't be removed from the inventory when built.
- Added some functions for finding Schematics

### V2.3.0

- Added ability to build variations of structures.
- Added TryFindRecipe() function.

### V2.2.0

- Fixed a bug that caused duplicate UnlockStates to be created for custom Unlocks.
- Added functions to build machines without their static meshes being invisible.

### V2.1.0

- Added UpdateUnlockTier() function.
- Removed wrong info from function comments.

### V2.0.1

- Removed log spam

### V2.0.0

- Updated for game version V0.2.1c
- Fixed adding new custom unlocks
- Reduced log spam with new function arguments (Developers see the linked GitHub repo)
- Updated ResourceNames
- Updated UnlockNames

### V1.0.0

- Initial release.

## Credits



## Disclaimer

Note: NEW Games must be loaded, saved, and reloaded for mods to take effect. Existing saves will auto-apply mods. 
Please be sure to backup your saves before using mods: AppData\LocalLow\Fire Hose Games\Techtonica 
USE AT YOUR OWN RISK! Techtonica Devs do not provide support for Mods, and cannot recover saves damaged by mod usage.

Some assets may come from Techtonica or from the website created and owned by Fire Hose Games, who hold the copyright of Techtonica. All trademarks and registered trademarks present in any images are proprietary to Fire Hose Games.

